SET DEFINE OFF;

--
-- 
-- ____________________________________________________________________________________________
--  /!\ ATTENTION /!\  fichier encodé en UTF-8   (  il peut  contenir des é è ç à î ê ô ... )
-- ____________________________________________________________________________________________
--
--

--
-- 
-- Fichier: n°1
-- Type: DDL
-- Schéma:  RECHERCHE
-- Numéro de version :  1.0.0
-- Date de publication :  07/12/2010
-- Auteurs : Julien Lafourcade, Jean-Marc Pussacq, Bruno Garnier
-- Licence : CeCILL version 2
--



whenever sqlerror exit sql.sqlcode ;


-- privileges
GRANT REFERENCES ON GRHUM.INDIVIDU_ULR TO RECHERCHE;
GRANT REFERENCES ON GRHUM.STRUCTURE_ULR TO RECHERCHE;
GRANT REFERENCES ON GRHUM.PERSONNE TO RECHERCHE;
GRANT REFERENCES ON ACCORDS.AVENANT TO RECHERCHE;
GRANT SELECT ON ACCORDS.AVENANT TO RECHERCHE;
GRANT UPDATE ON ACCORDS.AVENANT TO RECHERCHE;
GRANT REFERENCES ON ACCORDS.CONTRAT TO RECHERCHE;
GRANT SELECT ON ACCORDS.CONTRAT TO RECHERCHE;
GRANT UPDATE ON ACCORDS.CONTRAT TO RECHERCHE;
GRANT REFERENCES ON ACCORDS.PROJET TO RECHERCHE;
GRANT SELECT ON ACCORDS.PROJET TO RECHERCHE;
GRANT SELECT ON ACCORDS.PROJET_CONTRAT TO RECHERCHE;
GRANT REFERENCES ON JEFY_ADMIN.UTILISATEUR TO RECHERCHE;
GRANT SELECT ON GRHUM.INDIVIDU_ULR TO RECHERCHE;
GRANT SELECT ON GRHUM.STRUCTURE_ULR TO RECHERCHE;
GRANT SELECT ON GRHUM.ASSOCIATION TO RECHERCHE;
GRANT SELECT ON GRHUM.REPART_STRUCTURE TO RECHERCHE;
GRANT SELECT ON GRHUM.REPART_ASSOCIATION TO RECHERCHE;
GRANT SELECT ON GRHUM.REPART_TYPE_GROUPE TO RECHERCHE;

GRANT SELECT ON JEFY_ADMIN.EXERCICE_COCKTAIL TO RECHERCHE;
GRANT REFERENCES ON JEFY_ADMIN.EXERCICE_COCKTAIL TO RECHERCHE;
GRANT REFERENCES ON GRHUM.LANGUE TO RECHERCHE;
GRANT SELECT ON GRHUM.LANGUE TO RECHERCHE;
GRANT REFERENCES ON GRHUM.DOMAINE_SCIENTIFIQUE TO RECHERCHE;
GRANT SELECT ON GRHUM.DOMAINE_SCIENTIFIQUE TO RECHERCHE;
GRANT REFERENCES ON GRHUM.LABELS TO RECHERCHE;
GRANT SELECT ON GRHUM.LABELS TO RECHERCHE;
GRANT REFERENCES ON COURRIER.COURRIER TO RECHERCHE;
GRANT SELECT ON COURRIER.COURRIER TO RECHERCHE;
GRANT REFERENCES ON GRHUM.EVT_EVENEMENT TO RECHERCHE;
GRANT SELECT ON GRHUM.EVT_EVENEMENT TO RECHERCHE;
GRANT SELECT ON GRHUM.COMPTE TO RECHERCHE;
GRANT SELECT ON GRHUM.GRHUM_PARAMETRES TO RECHERCHE;


-- les séquences : 
CREATE SEQUENCE RECHERCHE.AAP_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.CONTRAT_RECHERCHE_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.PROJET_SCIENTIFIQUE_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.REPART_APPORT_DAJ_CONT_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.REPART_APPORT_DRV_CONT_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.REPART_CONTRAT_LANGUE_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.REPART_TYPE_RES_CONT_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.VALIDATION_CONTRATS_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.REPART_TYPE_FINANC_AAP_SEQ INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE;


CREATE SEQUENCE RECHERCHE.REPART_UNIT_RECH_DOM_SC_SEQ INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE;
CREATE SEQUENCE RECHERCHE.RECONNAISSANCE_UNITE_SEQ INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE;
CREATE SEQUENCE RECHERCHE.DOTATION_ANNUELLES_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;
CREATE SEQUENCE RECHERCHE.EVALUATION_MESR_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;

CREATE SEQUENCE RECHERCHE.MOTS_CLES_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;
CREATE SEQUENCE RECHERCHE.REPART_MC_DS_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;
CREATE SEQUENCE RECHERCHE.REPART_MC_UR_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;

CREATE SEQUENCE RECHERCHE.GRD_SECT_DISCIPLINAIRE_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;
CREATE SEQUENCE RECHERCHE.REPART_GRD_SECT_DS_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;

CREATE SEQUENCE RECHERCHE.PROGRAMMES_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;
CREATE SEQUENCE RECHERCHE.PROGRAMME_ANNEES_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;

CREATE SEQUENCE RECHERCHE.EVALUATION_NOTES_EQUIPES_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;
CREATE SEQUENCE RECHERCHE.EVALUATION_DOCUMENT_SEQ INCREMENT BY 1 START WITH 1 NOCACHE  NOORDER  NOCYCLE ;

CREATE SEQUENCE RECHERCHE.DB_VERSION_SEQ START WITH 1 NOCACHE;

CREATE SEQUENCE RECHERCHE.NOMENCLATURE_NOMENCLATURES_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;
CREATE SEQUENCE RECHERCHE.NOMENCLATURE_OBJETS_SEQ  INCREMENT BY 1 START WITH 1 MINVALUE 1 NOCACHE ;


 CREATE TABLE RECHERCHE.DB_VERSION
 (
  DBV_ID       NUMBER(4) NOT NULL,
  DBV_LIBELLE  VARCHAR2(15 BYTE) NOT NULL,
  DBV_DATE     DATE NOT NULL,
  DBV_INSTALL  DATE,
  DBV_COMMENT  VARCHAR2(2000 BYTE)
 );

COMMENT ON TABLE RECHERCHE.DB_VERSION IS 'Historique des versions du schéma du user RECHERCHE';
COMMENT ON COLUMN RECHERCHE.DB_VERSION.DBV_ID IS 'Identifiant de la version';
COMMENT ON COLUMN RECHERCHE.DB_VERSION.DBV_LIBELLE IS 'Libelle de la version';
COMMENT ON COLUMN RECHERCHE.DB_VERSION.DBV_DATE IS 'Date de release de la version';
COMMENT ON COLUMN RECHERCHE.DB_VERSION.DBV_INSTALL IS 'Date d''installation de la version. Si non renseigné, la version n''est pas complètement installée.';
COMMENT ON COLUMN RECHERCHE.DB_VERSION.DBV_COMMENT IS 'Le commentaire : une courte description de cette version de la base de données.';


ALTER TABLE RECHERCHE.DB_VERSION ADD (
 CONSTRAINT PK_DB_VERSION  PRIMARY KEY (DBV_ID)
 USING INDEX TABLESPACE INDX_GRHUM );


CREATE TABLE RECHERCHE.AAP
(
AAP_ORDRE NUMBER NOT NULL,
CON_ORDRE NUMBER NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
D_CREATION DATE, 
PERS_ID_MODIFICATION NUMBER, 
D_MODIFICATION DATE, 
DATE_DEPOT_DOSSIER DATE,
MOYEN_DEPOT_DOSSIER VARCHAR2(30),
DOSSIER_COMPLET NUMBER(1),
AVIS_RAPPORTEUR_DESIGNE VARCHAR2(30),
DATE_PASSAGE_CONSEIL_RECHERCHE DATE,
AVIS_PASSAGE_CONSEIL_RECHERCHE VARCHAR2(30),
DATE_PASSAGE_COM_MIXTE DATE,
AVIS_PASSAGE_COM_MIXTE VARCHAR2(30),
DATE_PASSAGE_CS DATE,
AVIS_PASSAGE_CS VARCHAR2(30),
DATE_ENV_DOSSIER_FIN DATE,
SUPPORT_ENV_FINANCEUR VARCHAR2(10),
DATE_COM_PERMANANT DATE,
TYPE_FINANCEMENT_DEMANDE VARCHAR2(50),
CLASSEMENT_PASSAGE_CS NUMBER,
ETAT_ACCEPT VARCHAR2(10),
DATE_REFUS_ACCEPT DATE,
APP_DOMAINE_SCIENT_ORDRE NUMBER,
APP_PROG_ID NUMBER,
APP_SS_PROG_ID NUMBER,
MOY_NOTIF_REF_ACC VARCHAR2(10),
MONTANT_DEMANDE NUMBER,
SUBVENTION_OBT NUMBER(1), 
MONTANT_OBT NUMBER,
TYPE_SUBV_OBT VARCHAR2(10),
SUIVI_VALO VARCHAR2(10),
D_ALERTE_SUIVI DATE,
SUJET_ALERTE_SUIVI VARCHAR2(250),
D_TRANSFERT_VALO DATE,
D_TRANSFERT_FINANCIER DATE,
D_ALERTE DATE,
SUJET_ALERTE VARCHAR2(250),
D_ARCHIVAGE DATE,
ETAT_MONTAGE VARCHAR2(10),
AAP_SUPPR NUMBER(1) DEFAULT 0
);

ALTER TABLE RECHERCHE.AAP ADD (PRIMARY KEY (AAP_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.AAP ADD (
	CONSTRAINT FK_AAP_DOMAINE_SCIENTIFIQUE 
	FOREIGN KEY (APP_DOMAINE_SCIENT_ORDRE) 
	REFERENCES GRHUM.DOMAINE_SCIENTIFIQUE (DS_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.CONTRAT_RECHERCHE
(
CONR_ORDRE NUMBER NOT NULL,
CON_ORDRE NUMBER NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE,
PROGRAMME_ID NUMBER,
SS_PROGRAMME_ID NUMBER,
DATE_OUVERT_DOSSIER DATE,
DATE_NOTIF DATE,
DATE_ARCHIVAGE DATE,
ZG_ORDRE NUMBER,
TYPE_INTERVENTION VARCHAR2(10),
SUIVI_ADMIN VARCHAR2(10),
REDACTION_CONTRAT VARCHAR2(10),
REDACTION_CLAUSES_PI VARCHAR2(10),
PARTICIAPATION_DAJ_NEGO NUMBER(1),
UTIL_CONTRAT_TYPE_DAJ NUMBER(1),
MONTANT_AUGMENTATION NUMBER,
PROPRIETE_RESULTATS VARCHAR2(10),
EXPLOITATION_RESULTATS VARCHAR2(10),
SUIVI_VALO VARCHAR2(10),
SUIVI_VALO_EVT_ID NUMBER,
TAUX_PRELEV_EFFECT NUMBER,
MONTANT_PRELEV_REFFECT NUMBER,
REDEVANCES NUMBER(1),
SOUMIS_TVA NUMBER(1),
TAUX_TVA NUMBER,
MONTANT_DEMANDE NUMBER,
SUBVENTION_OBT NUMBER(1), 
MONTANT_OBT NUMBER,
DOMAINE_SCIENT_ORDRE NUMBER,
CR_SUPPR NUMBER(1)
);

ALTER TABLE RECHERCHE.CONTRAT_RECHERCHE ADD (PRIMARY KEY (CONR_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.CONTRAT_RECHERCHE ADD (
	CONSTRAINT FK_CONR_EVT_SUIVI 
	FOREIGN KEY (SUIVI_VALO_EVT_ID) 
	REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.REPART_CONTRAT_LANGUE
(
RCL_ORDRE NUMBER NOT NULL,
CONR_ORDRE NUMBER NOT NULL,
C_LANGUE VARCHAR2(2) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_CONTRAT_LANGUE ADD (PRIMARY KEY (RCL_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_CONTRAT_LANGUE
ADD (
	CONSTRAINT FK_RCL_LANGUE 
	FOREIGN KEY (C_LANGUE) 
	REFERENCES GRHUM.LANGUE (C_LANGUE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.REPART_CONTRAT_LANGUE
ADD (
	CONSTRAINT FK_RCL_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);


--
-- REPARTITION DES APPORTS DRV POUR LES CONTRATS
--

CREATE TABLE RECHERCHE.REPART_APPORT_DRV_CONT
(
RADRVC_ORDRE NUMBER NOT NULL,
CONR_ORDRE NUMBER NOT NULL,
APPORT_CONT_DRV VARCHAR2(20) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_APPORT_DRV_CONT ADD (PRIMARY KEY (RADRVC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_APPORT_DRV_CONT
ADD (
	CONSTRAINT FK_RADRV_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

--
-- REPARTITION DES APPORTS DAJ POUR LES CONTRATS
--

CREATE TABLE RECHERCHE.REPART_APPORT_DAJ_CONT
(
RADAJC_ORDRE NUMBER NOT NULL,
CONR_ORDRE NUMBER NOT NULL,
APPORT_CONT_DAJ VARCHAR2(20) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_APPORT_DAJ_CONT ADD (PRIMARY KEY (RADAJC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_APPORT_DAJ_CONT
ADD (
	CONSTRAINT FK_RADAJ_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

-- REPARTITION DES TYPES DE RESULTATS POUR LES CONTRATS

CREATE TABLE RECHERCHE.REPART_TYPE_RES_CONT
(
RTRC_ORDRE NUMBER NOT NULL,
CONR_ORDRE NUMBER NOT NULL,
TYPE_RES VARCHAR2(20) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_TYPE_RES_CONT ADD (PRIMARY KEY (RTRC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_TYPE_RES_CONT
ADD (
	CONSTRAINT FK_RTR_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

-- ETATS DE VALIDATION DES CONTRATS

CREATE TABLE RECHERCHE.VALIDATION_CONTRATS 
(
  VC_ORDRE NUMBER NOT NULL,
  CONR_ORDRE NUMBER NOT NULL,
  T_VALIDATION VARCHAR2(20) NOT NULL,
  VALIDE NUMBER NOT NULL,
  DATE_VALIDATION DATE,
  COMMENTAIRE VARCHAR2(1024),
  PERS_ID_CREATION NUMBER NOT NULL, 
  PERS_ID_MODIFICATION NUMBER,
  D_CREATION DATE NOT NULL, 
  D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.VALIDATION_CONTRATS ADD (PRIMARY KEY (VC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);
  
ALTER TABLE RECHERCHE.VALIDATION_CONTRATS
ADD (
	CONSTRAINT FK_VC_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);  
  
-- REPARTITION TYPES FINANCEMENTS AAP

CREATE TABLE RECHERCHE.REPART_TYPE_FINANC_AAP 
(
  RTFC_ORDRE NUMBER NOT NULL,
  AAP_ORDRE NUMBER NOT NULL,
  T_FINANCEMENT VARCHAR2(20) NOT NULL,
  MONTANT_DEMANDE NUMBER,
  MONTANT_OBTENU NUMBER,
  PERS_ID_CREATION NUMBER NOT NULL, 
  PERS_ID_MODIF NUMBER,
  D_CREATION DATE NOT NULL, 
  D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_TYPE_FINANC_AAP ADD (PRIMARY KEY (RTFC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);
  
ALTER TABLE RECHERCHE.REPART_TYPE_FINANC_AAP
ADD (
	CONSTRAINT FK_RTFC_AAP
	FOREIGN KEY (AAP_ORDRE) 
	REFERENCES RECHERCHE.AAP (AAP_ORDRE) DEFERRABLE INITIALLY DEFERRED
);  


-- PROJET SCIENTIFIQUE

CREATE TABLE RECHERCHE.PROJET_SCIENTIFIQUE
(
PRSC_ORDRE                   NUMBER           NOT NULL,
PJT_ID					     NUMBER			  NOT NULL,
PERS_ID_CREATION			 NUMBER			  NOT NULL, 
PERS_ID_MODIFICATION         NUMBER					  ,
D_CREATION                   DATE             NOT NULL, 
D_MODIFICATION               DATE			          ,
PRSC_SUPPR                   NUMBER(1)
);

ALTER TABLE RECHERCHE.PROJET_SCIENTIFIQUE ADD (PRIMARY KEY (PRSC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

CREATE TABLE RECHERCHE.PROGRAMMES
(
ID NUMBER NOT NULL,
CODE VARCHAR2(25) NOT NULL,
C_STRUCTURE VARCHAR2(10) NOT NULL,
LL_PROGRAMME VARCHAR2(500) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER NOT NULL,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE NOT NULL,
MODIFIABLE NUMBER(1) NOT NULL
);

ALTER TABLE RECHERCHE.PROGRAMMES ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.PROGRAMMES ADD (
	CONSTRAINT FK_PROG_REF_STRUCT 
	FOREIGN KEY (C_STRUCTURE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);




CREATE TABLE RECHERCHE.PROGRAMME_ANNEES
(
	ID NUMBER NOT NULL,
	ANNEE NUMBER NOT NULL,
	PROGRAMME_ID NUMBER NOT NULL,
	PERS_ID_CREATION NUMBER NOT NULL, 
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL, 
	D_MODIFICATION DATE NOT NULL
);

ALTER TABLE RECHERCHE.PROGRAMME_ANNEES ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.PROGRAMME_ANNEES ADD (
	CONSTRAINT FK_PA_REF_PROGRAMME 
	FOREIGN KEY (PROGRAMME_ID) 
	REFERENCES RECHERCHE.PROGRAMMES (ID) DEFERRABLE INITIALLY DEFERRED
);


CREATE OR REPLACE PROCEDURE RECHERCHE.INSERT_OR_UPDATE_PROGRAMME (
    CODE_PROGRAMME RECHERCHE.PROGRAMMES.CODE%TYPE,
    LL_PROGRAMME RECHERCHE.PROGRAMMES.LL_PROGRAMME%TYPE,
    C_STRUCTURE RECHERCHE.PROGRAMMES.C_STRUCTURE%TYPE,
    MODIFIABLE RECHERCHE.PROGRAMMES.MODIFIABLE%TYPE,
    UTL_PERS_ID RECHERCHE.PROGRAMMES.PERS_ID_CREATION%TYPE
) IS
-- ------------
-- DECLARATIONS
-- ------------
persid INTEGER;
count_existant INTEGER;
modifiable_existant NUMBER(1);
-- ---------
-- PRINCIPAL
-- ---------
BEGIN


  if UTL_PERS_ID IS NULL then  
    select pers_id  into persid from grhum.grhum_parametres gp inner join grhum.compte c on gp.param_value = c.cpt_login where param_key = 'GRHUM_CREATEUR' and rownum = 1;
  else 
    persid := UTL_PERS_ID; 
  end if;

  select count(*) into count_existant from recherche.programmes where code = CODE_PROGRAMME;

  if count_existant = 1 then
      select modifiable into modifiable_existant from recherche.programmes where code = CODE_PROGRAMME;
      if modifiable_existant = 1 then
        update recherche.programmes set c_structure = C_STRUCTURE, ll_programme = LL_PROGRAMME, pers_id_modification = persid, d_modification = sysdate where code = CODE_PROGRAMME;
      end if;
  else
    insert into recherche.programmes (id, code, c_structure, ll_programme, pers_id_creation, pers_id_modification, d_creation, d_modification, modifiable) values (recherche.programmes_seq.nextval, CODE_PROGRAMME, C_STRUCTURE, LL_PROGRAMME, persid, persid, sysdate, sysdate, MODIFIABLE);
  end if;




END;
/


-- UNITE DE RECHERCHE

-- TABLE DE REPARTITION DES DS PAR UNITE
CREATE TABLE RECHERCHE.REPART_UNIT_RECH_DOM_SC
(
	RURDS_ID NUMBER NOT NULL,
	C_STRUCTURE VARCHAR2(10) NOT NULL,
	DOMAINE_SCIENT_ORDRE NUMBER NOT NULL,
	PRINCIPAL NUMBER(1),
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL,
	D_MODIFICATION DATE NOT NULL
);

ALTER TABLE RECHERCHE.REPART_UNIT_RECH_DOM_SC ADD (PRIMARY KEY (RURDS_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_UNIT_RECH_DOM_SC ADD (
	CONSTRAINT FK_RURDS_DS 
	FOREIGN KEY (DOMAINE_SCIENT_ORDRE) 
	REFERENCES GRHUM.DOMAINE_SCIENTIFIQUE (DS_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.REPART_UNIT_RECH_DOM_SC ADD (
	CONSTRAINT FK_RURDS_C_STR
	FOREIGN KEY (C_STRUCTURE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.GRD_SECT_DISCIPLINAIRE 
(
	GSD_ID NUMBER NOT NULL,
	GSD_LIBELLE VARCHAR2(50) NOT NULL
);

ALTER TABLE RECHERCHE.GRD_SECT_DISCIPLINAIRE ADD (PRIMARY KEY (GSD_ID) USING INDEX TABLESPACE INDX_GRHUM);

CREATE TABLE RECHERCHE.REPART_GRD_SECT_DS 
(
	GSDS_ID NUMBER NOT NULL,
	GSD_ID NUMBER NOT NULL,
	DS_ID NUMBER NOT NULL
);

ALTER TABLE RECHERCHE.REPART_GRD_SECT_DS ADD (PRIMARY KEY (GSDS_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_GRD_SECT_DS ADD (
	CONSTRAINT FK_GSDS_GSD_ID 
	FOREIGN KEY (GSD_ID) 
	REFERENCES RECHERCHE.GRD_SECT_DISCIPLINAIRE (GSD_ID) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.RECONNAISSANCE_UNITE
(
	REC_UNI_ID NUMBER NOT NULL,
	C_STR_UNITE VARCHAR2(10) DEFAULT '0' NOT NULL,
	REC_LABEL VARCHAR2(10),
	REC_NUMERO NUMBER NOT NULL,
	REC_DATE_DEBUT DATE NOT NULL,
	REC_DATE_FIN DATE,
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL,
	D_MODIFICATION DATE NOT NULL
);

ALTER TABLE RECHERCHE.RECONNAISSANCE_UNITE ADD (PRIMARY KEY (REC_UNI_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.RECONNAISSANCE_UNITE ADD (
	CONSTRAINT FK_RU_C_STR_UNITE
	FOREIGN KEY (C_STR_UNITE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.TYPE_DOTATIONS 
(
	ID NUMBER NOT NULL,
	CODE VARCHAR2(20) NOT NULL,
	LIBELLE VARCHAR2(200) NOT NULL
);

ALTER TABLE RECHERCHE.TYPE_DOTATIONS ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);


create table RECHERCHE.DOTATION_ANNUELLES
(
	ORDRE NUMBER NOT NULL,
	C_STR VARCHAR2(10) NOT NULL,
	C_STR_PROVENANCE VARCHAR2(10),
	TYPE_DOTATION_ID NUMBER NOT NULL,
	MONTANT NUMBER NOT NULL,
	ANNEE NUMBER(4) NOT NULL,
	COMMENTAIRE VARCHAR2(255),
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL,
	D_MODIFICATION DATE NOT NULL 
);



ALTER TABLE RECHERCHE.DOTATION_ANNUELLES ADD (PRIMARY KEY (ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.DOTATION_ANNUELLES ADD (
	CONSTRAINT FK_DA_C_STR
	FOREIGN KEY (C_STR) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.DOTATION_ANNUELLES ADD (
	CONSTRAINT FK_DA_C_STR_PROV
	FOREIGN KEY (C_STR_PROVENANCE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);


ALTER TABLE RECHERCHE.DOTATION_ANNUELLES ADD (
	CONSTRAINT FK_DA_T_DOTATION 
	FOREIGN KEY (TYPE_DOTATION_ID) 
	REFERENCES RECHERCHE.TYPE_DOTATIONS (ID) DEFERRABLE INITIALLY DEFERRED
);


-- Evaluation MESR
CREATE TABLE RECHERCHE.EVALUATION_MESR
(
	EVAL_MESR_ID NUMBER NOT NULL,
	C_STRUCT_UNITE VARCHAR2(10) DEFAULT '0' NOT NULL,
	TITRE VARCHAR2(255) DEFAULT 'TITRE' NOT NULL,
	ANNEE NUMBER(4) NOT NULL,
	DATE_RECEPTION_DOSSIER_DRV DATE,
	DOSSIER_COMPLET NUMBER(1),
	DATE_PASSAGE_CS DATE,
	AVIS_CS VARCHAR2(20),
	DATE_PASSAGE_CA DATE,
	AVIS_CA VARCHAR2(20),
	DATE_ENVOI_AERES DATE,
	DATE_ENVOI_MESR DATE,
	NOTE_CAL_SCIENT_PROD VARCHAR2(5),
	NOTE_RAY_ATTR VARCHAR2(5),
	NOTE_START_GOUV VARCHAR2(5),
	NOTE_APPREC_SUJ VARCHAR2(5),
	DEBUT_VISITE_AERES DATE,
	FIN_VISITE_AERES DATE,
	COU_RAPPORT_AERES NUMBER,
	COU_REPONSE_AERES NUMBER,
	COU_AVIS_DEF_MSTP NUMBER,
	ALRM_MI_PARCOURS_DATE DATE,
	ALRM_MI_PARCOURS_DEST NUMBER,
	ALRM_MI_PARCOURS_TXT VARCHAR(250),
	LBL_DEMANDE VARCHAR2(10),
	LBL_OBTENU VARCHAR2(10),
	NOTE_AERES VARCHAR2(10),
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL,
	D_MODIFICATION DATE NOT NULL 
);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (PRIMARY KEY (EVAL_MESR_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (
	CONSTRAINT FK_EVME_C_STR
	FOREIGN KEY (C_STRUCT_UNITE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (
	CONSTRAINT FK_EVME_ALRM_MP_DEST
	FOREIGN KEY (ALRM_MI_PARCOURS_DEST) 
	REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (
	CONSTRAINT FK_EVME_LBL_DEM
	FOREIGN KEY (LBL_DEMANDE) 
	REFERENCES GRHUM.LABELS (LAB_ABR) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (
	CONSTRAINT FK_EVME_LBL_OBT
	FOREIGN KEY (LBL_OBTENU) 
	REFERENCES GRHUM.LABELS (LAB_ABR) DEFERRABLE INITIALLY DEFERRED
);


-- gestion des mots-clés

CREATE TABLE RECHERCHE.MOTS_CLES (
	MC_ID NUMBER(38) NOT NULL,
	MC_LIBELLE VARCHAR2(100) NOT NULL
);

ALTER TABLE RECHERCHE.MOTS_CLES ADD (PRIMARY KEY (MC_ID) USING INDEX TABLESPACE INDX_GRHUM);

CREATE TABLE RECHERCHE.REPART_MC_DS (
	MCDS_ID NUMBER(38) NOT NULL,
	MC_ID NUMBER NOT NULL,
	DS_ORDRE NUMBER NOT NULL
);

ALTER TABLE RECHERCHE.REPART_MC_DS ADD (PRIMARY KEY (MCDS_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_MC_DS ADD (
	CONSTRAINT FK_MCDS_DS 
	FOREIGN KEY (DS_ORDRE) 
	REFERENCES GRHUM.DOMAINE_SCIENTIFIQUE (DS_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.REPART_MC_DS ADD (
	CONSTRAINT FK_MCDS_MC 
	FOREIGN KEY (MC_ID) 
	REFERENCES RECHERCHE.MOTS_CLES (MC_ID) DEFERRABLE INITIALLY DEFERRED
);



CREATE TABLE RECHERCHE.REPART_MC_UR (
	MCUR_ID NUMBER(38) NOT NULL,
	MC_ID NUMBER NOT NULL,
	C_STRUCTURE VARCHAR2(10) NOT NULL
);

ALTER TABLE RECHERCHE.REPART_MC_UR ADD (PRIMARY KEY (MCUR_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_MC_UR ADD (
	CONSTRAINT FK_MCUR_UR 
	FOREIGN KEY (C_STRUCTURE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.REPART_MC_UR ADD (
	CONSTRAINT FK_MCUR_MC 
	FOREIGN KEY (MC_ID) 
	REFERENCES RECHERCHE.MOTS_CLES (MC_ID) DEFERRABLE INITIALLY DEFERRED
);


CREATE TABLE RECHERCHE.EVALUATION_NOTES_EQUIPES (

  ID NUMBER NOT NULL,
  C_STRUCTURE VARCHAR2(10) NOT NULL,
	NOTE VARCHAR2(5) NOT NULL,
  EVALUATION_ID NUMBER NOT NULL,
	PERS_ID_CREATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL
  
);

ALTER TABLE RECHERCHE.EVALUATION_NOTES_EQUIPES ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.EVALUATION_NOTES_EQUIPES ADD (
	CONSTRAINT FK_EVALNOT_EQ_REF_STRUCT 
	FOREIGN KEY (C_STRUCTURE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);


CREATE TABLE RECHERCHE.EVALUATION_DOCUMENT (
  ID NUMBER NOT NULL,
  EVALUATION_ID NUMBER NOT NULL,
	DOCUMENT_ID NUMBER(38) NOT NULL,
	PERS_ID_CREATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL
);

ALTER TABLE RECHERCHE.EVALUATION_DOCUMENT ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.EVALUATION_DOCUMENT ADD (
	CONSTRAINT FK_EVALDOC_REF_DOCUMENT 
	FOREIGN KEY (EVALUATION_ID) 
	REFERENCES RECHERCHE.EVALUATION_MESR (EVAL_MESR_ID) DEFERRABLE INITIALLY DEFERRED
);



-- NOMENCLATURES

create table RECHERCHE.NOMENCLATURE_NOMENCLATURES
(
  ID NUMBER NOT NULL,
  STR_ID VARCHAR2(255) NOT NULL,
  LIBELLE VARCHAR2(255) NOT NULL,
  DESCRIPTION VARCHAR2(255),
  -- NN_VISIBLE NUMBER(1) NOT NULL,
  TYPE_NOMENCLATURE VARCHAR2(10) NOT NULL,
  TYPE_VALEURS VARCHAR2(10) NOT NULL,
  PERS_ID_CREATION NUMBER NOT NULL,
  PERS_ID_MODIFICATION NUMBER NOT NULL,
  D_CREATION DATE NOT NULL,
  D_MODIFICATION DATE NOT NULL,
  VALID NUMBER(1) DEFAULT 1 NOT NULL,
  MODIFIABLE NUMBER(1) DEFAULT 1 NOT NULL,
  COMPLETABLE NUMBER(1) DEFAULT 1 NOT NULL
);

ALTER TABLE RECHERCHE.NOMENCLATURE_NOMENCLATURES ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

create table RECHERCHE.NOMENCLATURE_OBJETS
(
  ID NUMBER NOT NULL,
  NOMENCLATURE_ID NUMBER NOT NULL,
  CODE VARCHAR2(255),
  LIBELLE_COURT VARCHAR2(255),
  LIBELLE_COURT_CUSTOM VARCHAR2(255),
  LIBELLE_LONG VARCHAR2(255),
  LIBELLE_LONG_CUSTOM VARCHAR2(255),
  VALEUR VARCHAR2(255),
  DATE_DEBUT_VALIDITE DATE NOT NULL,
  DATE_FIN_VALIDITE DATE,
  POSITION NUMBER NOT NULL,
  PERS_ID_CREATION NUMBER NOT NULL,
  PERS_ID_MODIFICATION NUMBER NOT NULL,
  D_CREATION DATE NOT NULL,
  D_MODIFICATION DATE NOT NULL,
  VISIBLE NUMBER(1) DEFAULT 1 NOT NULL,
  PERSONNALISEE NUMBER(1) DEFAULT 0 NOT NULL,
  ORIGINE VARCHAR2(1) DEFAULT 'E' NOT NULL
);

ALTER TABLE RECHERCHE.NOMENCLATURE_OBJETS ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.NOMENCLATURE_OBJETS ADD (
  CONSTRAINT FK_NO_NN 
  FOREIGN KEY (NOMENCLATURE_ID) 
  REFERENCES RECHERCHE.NOMENCLATURE_NOMENCLATURES (ID) DEFERRABLE INITIALLY DEFERRED
);




create or replace PROCEDURE RECHERCHE.INS_NOMENCLATURE (
    STR_ID RECHERCHE.NOMENCLATURE_NOMENCLATURES.STR_ID%TYPE,
    LIBELLE RECHERCHE.NOMENCLATURE_NOMENCLATURES.LIBELLE%TYPE,
    DESCRIPTION RECHERCHE.NOMENCLATURE_NOMENCLATURES.DESCRIPTION%TYPE,
    TYPE_NOMENCLATURE RECHERCHE.NOMENCLATURE_NOMENCLATURES.TYPE_NOMENCLATURE%TYPE,
    TYPE_VALEURS RECHERCHE.NOMENCLATURE_NOMENCLATURES.TYPE_VALEURS%TYPE,
    VALID RECHERCHE.NOMENCLATURE_NOMENCLATURES.VALID%TYPE,
    MODIFIABLE RECHERCHE.NOMENCLATURE_NOMENCLATURES.MODIFIABLE%TYPE,
    COMPLETABLE RECHERCHE.NOMENCLATURE_NOMENCLATURES.COMPLETABLE%TYPE
) IS
-- ------------
-- DECLARATIONS
-- ------------
gc_persid INTEGER;
-- ---------
-- PRINCIPAL
-- ---------
BEGIN

select pers_id  into gc_persid from grhum.grhum_parametres gp 
  inner join grhum.compte c on gp.param_value = c.cpt_login
    where param_key = 'GRHUM_CREATEUR' and rownum = 1;
  
INSERT
INTO RECHERCHE.NOMENCLATURE_NOMENCLATURES
  (
    ID,
    STR_ID,
    LIBELLE,
    DESCRIPTION,
    TYPE_NOMENCLATURE,
    TYPE_VALEURS,
    PERS_ID_CREATION,
    PERS_ID_MODIFICATION,
    D_CREATION,
    D_MODIFICATION,
    VALID,
    MODIFIABLE,
    COMPLETABLE
  )
  VALUES
  (
    RECHERCHE.NOMENCLATURE_NOMENCLATURES_SEQ.NEXTVAL,
    STR_ID,
    LIBELLE,
    DESCRIPTION,
    TYPE_NOMENCLATURE,
    TYPE_VALEURS,
    gc_persid,
    gc_persid,
    sysdate,
    sysdate,
    VALID,
    MODIFIABLE,
    COMPLETABLE
  );

END;
/

create or replace PROCEDURE RECHERCHE.INS_NOMENCLATURE_OBJET ( 
    NOMENCLATURE_STR_ID RECHERCHE.NOMENCLATURE_NOMENCLATURES.STR_ID%TYPE,
    CODE RECHERCHE.NOMENCLATURE_OBJETS.CODE%TYPE,
    LIBELLE_COURT RECHERCHE.NOMENCLATURE_OBJETS.LIBELLE_COURT%TYPE,
    LIBELLE_LONG RECHERCHE.NOMENCLATURE_OBJETS.LIBELLE_LONG%TYPE,
    VALEUR RECHERCHE.NOMENCLATURE_OBJETS.VALEUR%TYPE,
    DATE_DEBUT_VALIDITE RECHERCHE.NOMENCLATURE_OBJETS.DATE_DEBUT_VALIDITE%TYPE,
    DATE_FIN_VALIDITE RECHERCHE.NOMENCLATURE_OBJETS.DATE_FIN_VALIDITE%TYPE,
    VISIBLE RECHERCHE.NOMENCLATURE_OBJETS.VISIBLE%TYPE,
    PERSONNALISEE RECHERCHE.NOMENCLATURE_OBJETS.PERSONNALISEE%TYPE,
    ORIGINE RECHERCHE.NOMENCLATURE_OBJETS.ORIGINE%TYPE
) IS
-- ------------
-- DECLARATIONS
-- ------------

gc_persid INTEGER;
nomenclature_id INTEGER;
count_objets INTEGER;
position INTEGER;
-- ---------
-- PRINCIPAL
-- ---------

BEGIN 
 
select pers_id  into gc_persid from grhum.grhum_parametres gp 
  inner join grhum.compte c on gp.param_value = c.cpt_login
    where param_key = 'GRHUM_CREATEUR' and rownum = 1;

select id into nomenclature_id from RECHERCHE.nomenclature_nomenclatures where str_id = NOMENCLATURE_STR_ID;

select count(*) into count_objets from RECHERCHE.nomenclature_objets where nomenclature_id = nomenclature_id;

if(count_objets = 0) THEN
  position := 0;
else
  select max(position) into position from RECHERCHE.nomenclature_objets where nomenclature_id = nomenclature_id;
end if;

INSERT
INTO RECHERCHE.NOMENCLATURE_OBJETS
  (
    ID,
    NOMENCLATURE_ID,
    CODE,
    LIBELLE_COURT,
    LIBELLE_COURT_CUSTOM,
    LIBELLE_LONG,
    LIBELLE_LONG_CUSTOM,
    VALEUR,
    DATE_DEBUT_VALIDITE,
    DATE_FIN_VALIDITE,
    POSITION,
    PERS_ID_CREATION,
    PERS_ID_MODIFICATION,
    D_CREATION,
    D_MODIFICATION,
    VISIBLE,
    PERSONNALISEE,
    ORIGINE
  )
  VALUES
  (
    RECHERCHE.NOMENCLATURE_OBJETS_SEQ.NEXTVAL,
    nomenclature_id,
    CODE,
    LIBELLE_COURT,
    null,
    LIBELLE_LONG,
    null,
    VALEUR,
    DATE_DEBUT_VALIDITE,
    DATE_FIN_VALIDITE,
    position,
    gc_persid,
    gc_persid,
    sysdate,
    sysdate,
    VISIBLE,
    PERSONNALISEE,
    ORIGINE
  );


END;
/



